diff --git a/src/common/ModulatorPresetManager.cpp b/src/common/ModulatorPresetManager.cpp
index 60496c2d4..6aa79ec2b 100644
--- a/src/common/ModulatorPresetManager.cpp
+++ b/src/common/ModulatorPresetManager.cpp
@@ -19,6 +19,8 @@
 #include "DebugHelpers.h"
 #include "SurgeStorage.h"
 #include "tinyxml/tinyxml.h"
+#include "DebugHelpers.h"
+#include "strnatcmp.h"
 
 namespace Surge
 {
@@ -103,6 +105,8 @@ void savePresetToUser( const fs::path & location, SurgeStorage *s, int scene, in
       // uhh ... do somethign I guess?
       std::cout << "Could not save" << std::endl;
    }
+
+   forcePresetRescan();
 }
 
 /*
@@ -202,14 +206,19 @@ void loadPresetFrom( const fs::path &location, SurgeStorage *s, int scene, int l
    }
 }
 
+static std::vector<Category> scanedPresets;
+static bool haveScanedPresets = false;
 
 std::vector<Category> getPresets( SurgeStorage *s )
 {
+   if (haveScanedPresets)
+      return scanedPresets;
+
    // Do a dual directory traversal of factory and user data with the fs::directory_iterator stuff looking for .lfopreset
    auto factoryPath = fs::path( { string_to_path(s->datapath) / fs::path{ PresetDir } } );
    auto userPath = fs::path( { string_to_path(s->userDataPath) / fs::path{ PresetDir } } );
 
-   std::vector<Category> res;
+   std::map<std::string, Category> resMap; // handy it is sorted!
 
    for( int i=0; i<2; ++i )
    {
@@ -221,34 +230,38 @@ std::vector<Category> getPresets( SurgeStorage *s )
          Category currentCategory;
          for (auto& d : fs::recursive_directory_iterator(p))
          {
-            // blah
-            auto base = fs::path(d).stem();
-            auto fn = fs::path(d).filename();
-            if (path_to_string(base) == path_to_string(fn))
+            auto dp = fs::path(d);
+            auto base = dp.stem();
+            auto fn = dp.filename();
+            auto ext = dp.extension();
+            if (path_to_string(ext) != ".modpreset")
             {
-               if (currentCategory.presets.size() > 0)
-               {
-                  std::sort(currentCategory.presets.begin(), currentCategory.presets.end(),
-                            [](const Preset& a, const Preset& b) { return a.name < b.name; });
-                  res.push_back(currentCategory);
-               }
-               currentCategoryName = path_to_string(base);
-               currentCategory = Category();
-               currentCategory.name = currentCategoryName;
-               currentCategory.isUserCategory = isU;
                continue;
             }
+            auto rd = path_to_string(dp.replace_filename(fs::path()));
+            rd = rd.substr(path_to_string(p).length() + 1);
+            rd = rd.substr(0, rd.length() - 1);
+
+            auto catName = rd;
+            auto ppos = rd.rfind(fs::path::preferred_separator);
+            auto pd = std::string();
+            if (ppos != std::string::npos)
+            {
+               pd = rd.substr(0, ppos);
+               catName = rd.substr(ppos + 1);
+            }
+            if (resMap.find(rd) == resMap.end())
+            {
+               resMap[rd] = Category();
+               resMap[rd].name = catName;
+               resMap[rd].parentPath = pd;
+               resMap[rd].path = rd;
+            }
 
-            Preset p;
-            p.name = path_to_string(base);
-            p.path = fs::path(d);
-            currentCategory.presets.push_back(p);
-         }
-         if (currentCategory.presets.size() > 0)
-         {
-            std::sort(currentCategory.presets.begin(), currentCategory.presets.end(),
-                      [](const Preset& a, const Preset& b) { return a.name < b.name; } );
-            res.push_back(currentCategory);
+            Preset prs;
+            prs.name = path_to_string(base);
+            prs.path = fs::path(d);
+            resMap[rd].presets.push_back(prs);
          }
       }
       catch (const fs::filesystem_error& e)
@@ -256,14 +269,25 @@ std::vector<Category> getPresets( SurgeStorage *s )
          // That's OK!
       }
    }
-   std::sort( res.begin(), res.end(), [](const Category &a, const Category &b ) {
-               if (a.isUserCategory == b.isUserCategory)
-                  return a.name < b.name;
-               if (a.isUserCategory)
-                  return true;
-               return false;
-               });
-    return res;
+   std::vector<Category> res;
+   for (auto& m : resMap)
+   {
+      std::sort(m.second.presets.begin(), m.second.presets.end(),
+                [](const Preset& a, const Preset& b) {
+                   return strnatcasecmp(a.name.c_str(), b.name.c_str()) < 0;
+                });
+
+      res.push_back(m.second);
+   }
+   scanedPresets = res;
+   haveScanedPresets = true;
+   return res;
+}
+
+void forcePresetRescan()
+{
+   haveScanedPresets = false;
+   scanedPresets.clear();
 }
 }
 }
diff --git a/src/common/ModulatorPresetManager.h b/src/common/ModulatorPresetManager.h
index 3837dca79..d7ac0e15a 100644
--- a/src/common/ModulatorPresetManager.h
+++ b/src/common/ModulatorPresetManager.h
@@ -45,11 +45,12 @@ struct Preset {
 
 struct Category {
    std::string name;
-   bool isUserCategory;
+   std::string path;
+   std::string parentPath;
    std::vector<Preset> presets;
 };
 
 std::vector<Category> getPresets( SurgeStorage *s );
-
+void forcePresetRescan();
 }
 }
\ No newline at end of file
diff --git a/src/common/gui/SurgeGUIEditor.cpp b/src/common/gui/SurgeGUIEditor.cpp
index 84198dcb2..e8ab050da 100644
--- a/src/common/gui/SurgeGUIEditor.cpp
+++ b/src/common/gui/SurgeGUIEditor.cpp
@@ -4980,9 +4980,13 @@ VSTGUI::COptionMenu *SurgeGUIEditor::makeLfoMenu(VSTGUI::CRect &menuRect)
    if (!presetCategories.empty())
       lfoSubMenu->addSeparator();
 
+   std::unordered_map<std::string, std::pair<COptionMenu*, bool>> subMenuMaps;
+   subMenuMaps[""] = std::make_pair(lfoSubMenu, true);
    for( auto const &cat : presetCategories )
    {
       COptionMenu *catSubMenu = new COptionMenu( menuRect, 0, 0, 0, 0, VSTGUI::COptionMenu::kNoDrawStyle);
+      subMenuMaps[cat.path] = std::make_pair(catSubMenu, false);
+
       for( auto const &p : cat.presets )
          addCallbackMenu(catSubMenu,
                          p.name,
@@ -4999,9 +5003,24 @@ VSTGUI::COptionMenu *SurgeGUIEditor::makeLfoMenu(VSTGUI::CRect &menuRect)
 
                             this->synth->refresh_editor = true;
                          });
-      lfoSubMenu->addEntry(catSubMenu, cat.name.c_str());
+      auto parentMenu = lfoSubMenu;
+      if (subMenuMaps.find(cat.parentPath) != subMenuMaps.end())
+      {
+         parentMenu = subMenuMaps[cat.parentPath].first;
+         if (!subMenuMaps[cat.parentPath].second)
+         {
+            subMenuMaps[cat.parentPath].second = true;
+            if (parentMenu->getNbEntries() > 0)
+               parentMenu->addSeparator();
+         }
+      }
+      parentMenu->addEntry(catSubMenu, cat.name.c_str());
       catSubMenu->forget();
    }
+
+   lfoSubMenu->addSeparator();
+   addCallbackMenu(lfoSubMenu, Surge::UI::toOSCaseForMenu("Rescan Presets"),
+                   []() { Surge::ModulatorPreset::forcePresetRescan(); });
    return lfoSubMenu;
 }
 
